function features = get_cnn_layer_cv(im, fparam, gparam)
% Extract cnn convolutional features using dnn module of OpenCV
    
    persistent loaded
    % Load network
    if (isempty(loaded))
        cvNN(fparam.net_conf, fparam.net_weights, fparam.target);
        loaded = true;
    end
    
    % Extract features
    features = cvNN(im, fparam.layer, ...
					'scale', fparam.scale, ...
					'size', fparam.size, ...
					'mean', fparam.mean);
    % Normalization
    if (iscell(features))
        % Multiple layers
        for i = 1:length(features)
            for cn = 1:size(features{i}, 3)
                fc = features{i}(:, :, cn);
                features{i}(:, :, cn) = fc / sqrt(abs(sum(fc(:))) + 0.001);
            end
        end
    else
        % Single layer
        for cn = 1:size(features, 3)
            fc = features(:, :, cn);
            features(:, :, cn) = fc / sqrt(abs(sum(fc(:))) + 0.001);
        end
    end
end
