function [ feature_image ] = get_fhog( im, fparam, gparam )
% Extract fhog features using piotrs toolbox.
% Parameters: hog-cell-size and number of orientations

    if (~isfield(fparam, 'nOrients'))
        fparam.nOrients = 9;
    end
    
    % [im_height, im_width, num_im_chan, num_images] = size(im);
    % feature_image = zeros(floor(im_height/gparam.cell_size), floor(im_width/gparam.cell_size), fparam.nDim, num_images, 'single');
    % for k = 1:num_images
    %     hog_image = fhog(single(im(:,:,:,k)), gparam.cell_size, fparam.nOrients);
    %     %the last dimension is all 0 so we can discard it
    %     feature_image(:,:,:,k) = hog_image(:,:,1:end-1);
    % end
    if (size(im, 3) == 3)
        im = rgb2gray(im);
    end
    hog_image = fhog(single(im), gparam.cell_size, fparam.nOrients);
    feature_image = hog_image(:, :, 1:(end - 1));
end